## ghc 9.6.6

=== driver/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

dir = driver
TOP = ..
include $(TOP)/mk/sub-makefile.mk

=== ghc/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

dir = ghc

include ../mk/compiler-ghc.mk

=== hadrian/bindist/Makefile ===
MAKEFLAGS += --no-builtin-rules
.SUFFIXES:

include ./mk/project.mk
include ./config.mk

.PHONY: default
default:
	@echo 'Run "make install" to install'
	@false

#-----------------------------------------------------------------------
# INSTALL RULES

# Hacky function to check equality of two strings
# TODO : find if a better function exists
eq=$(and $(findstring $(1),$(2)),$(findstring $(2),$(1)))

# the following is the work around suggested by @carter in #17418 during install
# time.  This should help us with code signing issues by removing extended
# attributes from all files.
ifeq "$(Darwin_Host)" "YES"
XATTR ?= /usr/bin/xattr
endif

# patchpackageconf
#
# Hacky function to patch up the 'haddock-interfaces' and 'haddock-html'
# fields in the package .conf files
#
# $1 = package name (ex: 'bytestring')
# $2 = path to .conf file
# $3 = Docs Directory
# $4 = (relative) path from $${pkgroot} to docs directory ($3)
# $5 = package name and version (ex: bytestring-0.13)
#
define patchpackageconf \
	# We fix the paths to haddock files by using the relative path from the pkgroot
	# to the doc files.
	cat '$2' | sed 's|haddock-interfaces.*|haddock-interfaces: "$${pkgroot}/$4/html/libraries/$5/$1.haddock"|' \
	         | sed 's|haddock-html.*|haddock-html: "$${pkgroot}/$4/html/libraries/$5"|' \
		 | sed 's|    $${pkgroot}/../../doc/html/.*||' \
	       > '$2.copy'
	# The rts package doesn't actually supply haddocks, so we stop advertising them
	# altogether.
	((echo "$1" | grep rts) && (cat '$2.copy' | sed 's|haddock-.*||' > '$2.copy.copy')) || (cat '$2.copy' > '$2.copy.copy')
	# We finally replace the original file.
	mv '$2.copy.copy' '$2'
	# Fix the mode, in case umask is set
	chmod 644 '$2'
endef

# QUESTION : should we use shell commands?


show:
	@echo '$(VALUE)="$($(VALUE))"'


.PHONY: install

ifeq "$(TargetOS_CPP)" "mingw32"
install_bin: install_mingw install_bin_direct
else
install_bin: install_bin_libdir install_wrappers
endif

install: install_bin install_lib
install: install_man install_docs update_package_db

ActualBinsDir=${ghclibdir}/bin
ifeq "$(RelocatableBuild)" "YES"
ActualLibsDir=${ghclibdir}
else
ActualLibsDir=${ghclibdir}/lib
endif
WrapperBinsDir=${bindir}

# N.B. this is duplicated from includes/ghc.mk.
lib/settings : config.mk
	@rm -f $@
	@echo '[("GCC extra via C opts", "$(GccExtraViaCOpts)")' >> $@
	@echo ',("C compiler command", "$(SettingsCCompilerCommand)")' >> $@
	@echo ',("C compiler flags", "$(SettingsCCompilerFlags)")' >> $@
	@echo ',("C++ compiler command", "$(SettingsCxxCompilerCommand)")' >> $@
	@echo ',("C++ compiler flags", "$(SettingsCxxCompilerFlags)")' >> $@
	@echo ',("C compiler link flags", "$(SettingsCCompilerLinkFlags)")' >> $@
	@echo ',("C compiler supports -no-pie", "$(SettingsCCompilerSupportsNoPie)")' >> $@
	@echo ',("Haskell CPP command", "$(SettingsHaskellCPPCommand)")' >> $@
	@echo ',("Haskell CPP flags", "$(SettingsHaskellCPPFlags)")' >> $@
	@echo ',("ld command", "$(SettingsLdCommand)")' >> $@
	@echo ',("ld flags", "$(SettingsLdFlags)")' >> $@
	@echo ',("ld supports compact unwind", "$(LdHasNoCompactUnwind)")' >> $@
	@echo ',("ld supports filelist", "$(LdHasFilelist)")' >> $@
	@echo ',("ld supports single module", "$(LdHasSingleModule)")' >> $@
	@echo ',("ld is GNU ld", "$(LdIsGNULd)")' >> $@
	@echo ',("Merge objects command", "$(SettingsMergeObjectsCommand)")' >> $@
	@echo ',("Merge objects flags", "$(SettingsMergeObjectsFlags)")' >> $@
	@echo ',("ar command", "$(SettingsArCommand)")' >> $@
	@echo ',("ar flags", "$(ArArgs)")' >> $@
	@echo ',("ar supports at file", "$(ArSupportsAtFile)")' >> $@
	@echo ',("ar supports -L", "$(ArSupportsDashL)")' >> $@
	@echo ',("ranlib command", "$(SettingsRanlibCommand)")' >> $@
	@echo ',("otool command", "$(SettingsOtoolCommand)")' >> $@
	@echo ',("install_name_tool command", "$(SettingsInstallNameToolCommand)")' >> $@
	@echo ',("touch command", "$(SettingsTouchCommand)")' >> $@
	@echo ',("dllwrap command", "$(SettingsDllWrapCommand)")' >> $@
	@echo ',("windres command", "$(SettingsWindresCommand)")' >> $@
	@echo ',("unlit command", "$$topdir/bin/unlit")' >> $@
	@echo ',("cross compiling", "$(CrossCompiling)")' >> $@
	@echo ',("target platform string", "$(TARGETPLATFORM)")' >> $@
	@echo ',("target os", "$(HaskellTargetOs)")' >> $@
	@echo ',("target arch", "$(HaskellTargetArch)")' >> $@
	@echo ',("target word size", "$(TargetWordSize)")' >> $@
	@echo ',("target word big endian", "$(TargetWordBigEndian)")' >> $@
	@echo ',("target has GNU nonexec stack", "$(TargetHasGnuNonexecStack)")' >> $@
	@echo ',("target has .ident directive", "$(TargetHasIdentDirective)")' >> $@
	@echo ',("target has subsections via symbols", "$(TargetHasSubsectionsViaSymbols)")' >> $@
	@echo ',("target has RTS linker", "$(TargetHasRTSLinker)")' >> $@
	@echo ',("target has libm", "$(TargetHasLibm)")' >> $@
	@echo ',("Unregisterised", "$(GhcUnregisterised)")' >> $@
	@echo ',("LLVM target", "$(LLVMTarget_CPP)")' >> $@
	@echo ',("LLVM llc command", "$(SettingsLlcCommand)")' >> $@
	@echo ',("LLVM opt command", "$(SettingsOptCommand)")' >> $@
	@echo ',("LLVM clang command", "$(SettingsClangCommand)")' >> $@
	@echo ',("Use inplace MinGW toolchain", "$(SettingsUseDistroMINGW)")' >> $@
	@echo
	@echo ',("Use interpreter", "$(GhcWithInterpreter)")' >> $@
	@echo ',("Support SMP", "$(GhcWithSMP)")' >> $@
	@echo ',("RTS ways", "$(GhcRTSWays)")' >> $@
	@echo ',("Tables next to code", "$(TablesNextToCode)")' >> $@
	@echo ',("Leading underscore", "$(LeadingUnderscore)")' >> $@
	@echo ',("Use LibFFI", "$(UseLibffiForAdjustors)")' >> $@
	@echo ',("RTS expects libdw", "$(GhcRtsWithLibdw)")' >> $@
	@echo "]" >> $@

# We need to install binaries relative to libraries.
BINARIES = $(wildcard ./bin/*)
install_bin_libdir:
	@echo "Copying binaries to $(DESTDIR)$(ActualBinsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(ActualBinsDir)"
	for i in $(BINARIES); do \
		if test -L "$$i"; then \
			cp -RP "$$i" "$(DESTDIR)$(ActualBinsDir)"; \
		else \
			$(INSTALL_PROGRAM) "$$i" "$(DESTDIR)$(ActualBinsDir)"; \
		fi; \
	done
	# Work around #17418 on Darwin
	if [ -e "${XATTR}" ]; then \
		"${XATTR}" -c -r "$(DESTDIR)$(ActualBinsDir)"; \
	fi

install_bin_direct:
	@echo "Copying binaries to $(DESTDIR)$(WrapperBinsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(WrapperBinsDir)"
	$(INSTALL_PROGRAM) ./bin/* "$(DESTDIR)$(WrapperBinsDir)/"

install_lib: lib/settings
	@echo "Copying libraries to $(DESTDIR)$(ActualLibsDir)"
	$(INSTALL_DIR) "$(DESTDIR)$(ActualLibsDir)"
	
	@dest="$(DESTDIR)$(ActualLibsDir)"; \
	cd lib; \
	for i in `$(FIND) . -type f`; do \
		$(INSTALL_DIR) "$$dest/`dirname $$i`" ; \
		case $$i in \
		  *.a) \
		    $(INSTALL_DATA) $$i "$$dest/`dirname $$i`" ; \
		    $(RANLIB_CMD) "$$dest"/$$i ;; \
		  *.dll) \
		    $(INSTALL_PROGRAM) $$i "$$dest/`dirname $$i`" ; \
		    $(STRIP_CMD) "$$dest"/$$i ;; \
		  *.so) \
		    $(INSTALL_SHLIB) $$i "$$dest/`dirname $$i`" ;; \
		  *.dylib) \
		    $(INSTALL_SHLIB) $$i "$$dest/`dirname $$i`" ;; \
		  *) \
		    $(INSTALL_DATA) $$i "$$dest/`dirname $$i`" ;; \
		esac; \
	done; \
	chmod ugo+rx "$$dest"/bin/*
	# Work around #17418 on Darwin
	if [ -e "${XATTR}" ]; then \
		"${XATTR}" -c -r "$(DESTDIR)$(ActualLibsDir)"; \
	fi

install_docs:
	@echo "Copying docs to $(DESTDIR)$(docdir)"
	$(INSTALL_DIR) "$(DESTDIR)$(docdir)"

	if [ -d doc ]; then \
		cd doc; $(FIND) . -type f -exec sh -c \
			'$(INSTALL_DIR) "$(DESTDIR)$(docdir)/`dirname $$1`" && $(INSTALL_DATA) "$$1" "$(DESTDIR)$(docdir)/`dirname $$1`"' \
			sh '{}' ';'; \
	fi

	if [ -d docs-utils ]; then \
		$(INSTALL_DIR) "$(DESTDIR)$(docdir)/html/libraries/"; \
		$(INSTALL_DATA) docs-utils/prologue.txt "$(DESTDIR)$(docdir)/html/libraries/"; \
		$(INSTALL_SCRIPT) docs-utils/gen_contents_index "$(DESTDIR)$(docdir)/html/libraries/"; \
	fi

MAN_SECTION := 1
MAN_PAGES := doc/users_guide/build-man/ghc.1

.PHONY: install_man
install_man:
	if [ -f $(MAN_PAGES) ]; then \
		$(INSTALL_DIR) "$(DESTDIR)$(mandir)"; \
		$(INSTALL_DIR) "$(DESTDIR)$(mandir)/man$(MAN_SECTION)"; \
		$(INSTALL_MAN) $(INSTALL_OPTS) $(MAN_PAGES) "$(DESTDIR)$(mandir)/man$(MAN_SECTION)"; \
	fi

export SHELL
.PHONY: install_wrappers
install_wrappers: install_bin_libdir install_hsc2hs_wrapper
	@echo "Installing wrapper scripts"
	$(INSTALL_DIR) "$(DESTDIR)$(WrapperBinsDir)"
	for p in `cd wrappers; $(FIND) . ! -type d`; do \
	    mk/install_script.sh "$$p" "$(DESTDIR)/$(WrapperBinsDir)/$$p" "$(WrapperBinsDir)" "$(ActualBinsDir)" "$(ActualBinsDir)/$$p" "$(ActualLibsDir)" "$(docdir)" "$(includedir)"; \
	done

.PHONY: install_hsc2hs_wrapper
install_hsc2hs_wrapper:
	@echo Copying hsc2hs wrapper
	cp mk/hsc2hs wrappers/hsc2hs-ghc-$(ProjectVersion)

PKG_CONFS = $(shell find "$(DESTDIR)$(ActualLibsDir)/package.conf.d" -name '*.conf' | sed "s:   :\0xxx\0:g")
update_package_db: install_bin install_lib
	@echo "Installing C++ standard library virtual package"
	$(INSTALL_DATA) mk/system-cxx-std-lib-1.0.conf "$(DESTDIR)$(ActualLibsDir)/package.conf.d"
	@echo "Updating the package DB"
	$(foreach p, $(PKG_CONFS),\
		$(call patchpackageconf,$(shell echo $(notdir $p) | sed 's/-\([0-9]*[0-9]\.\)*conf//g'),$(shell echo "$p" | sed 's:\0xxx\0:   :g'),$(docdir),$(shell mk/relpath.sh "$(ActualLibsDir)" "$(docdir)"),$(shell echo $(notdir $p) | sed 's/.conf//g')))
	'$(DESTDIR)$(ActualBinsDir)/$(CrossCompilePrefix)ghc-pkg' --global-package-db "$(DESTDIR)$(ActualLibsDir)/package.conf.d" recache

install_mingw:
	@echo "Installing MingGW"
	$(INSTALL_DIR) "$(DESTDIR)$(prefix)/mingw"
	cp -Rp ./mingw "$(DESTDIR)$(prefix)"

# END INSTALL
# ----------------------------------------------------------------------

=== nofib/spectral/Makefile ===
TOP = ..
include $(TOP)/mk/boilerplate.mk

# TODO(michalt): Re-enable `secretary` (requires `random`)
SUBDIRS = ansi atom awards banner boyer boyer2 calendar cichelli circsim \
          clausify constraints cryptarithm1 cryptarithm2 cse dom-lt eliza expert \
          exact-reals fft2 fibheaps fish gcd hartel integer knights lambda \
          last-piece lcss life mandel mandel2 mate minimax multiplier para \
          power pretty primetest puzzle rewrite scc simple sorting sphere \
          treejoin

include $(TOP)/mk/target.mk

=== utils/deriveConstants/Makefile ===
# -----------------------------------------------------------------------------
#
# (c) 2009-1012 The University of Glasgow
#
# This file is part of the GHC build system.
#
# To understand how the build system works and how to modify it, see
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/architecture
#      https://gitlab.haskell.org/ghc/ghc/wikis/building/modifying
#
# -----------------------------------------------------------------------------

dir = utils/deriveConstants
TOP = ../..
include $(TOP)/mk/sub-makefile.mk

=== libraries/Cabal/doc/Makefile ===
# Build and safety-check requirements.txt

# skjold needs a personal github access token.  This needs no permissions,
# it is only required to query the GitHub GraphQL API v4.
# See: https://pythonawesome.com/security-audit-python-project-dependencies-against-security-advisory-databases/
# We attempt to get it from the environment variable SKJOLD_GITHUB_API_TOKEN
# or GITHUB_TOKEN.
# It can also be passed to this Makefile via either:
#
#   make GITHUB_TOKEN=... (build-and-)check-requirements
#   make SKJOLD_GITHUB_API_TOKEN=... (build-and-)check-requirements
#
#
SKJOLD_GITHUB_API_TOKEN ?= ${GITHUB_TOKEN}

.PHONY: build-and-check-requirements
build-and-check-requirements: requirements.txt check-requirements

# Always rebuild requirements.txt
.PHONY: requirements.txt
# requirements.txt is generated from requirements.in
# via pip-compile included in the pip-tools package.
# See https://modelpredict.com/wht-requirements-txt-is-not-enough
requirements.txt: requirements.in
	. ../.python-sphinx-virtualenv/bin/activate \
	  && pip install --upgrade pip \
	  && pip install pip-tools \
	  && pip-compile requirements.in

# Check requirements.txt for security violations via skjold,
# configured in pyproject.toml.
# See: https://pythonawesome.com/security-audit-python-project-dependencies-against-security-advisory-databases/
.PHONY: check-requirements
check-requirements:
	@if [ -z "$${SKJOLD_GITHUB_API_TOKEN}" ] \
	; then \
	  echo "WARNING: Neither SKJOLD_GITHUB_API_TOKEN nor GITHUB_TOKEN is set." \
	; echo "Vulnerability check via skjold might fail when using the GitHub GraphQL API." \
	; fi
	. ../.python-sphinx-virtualenv/bin/activate \
	  && pip install skjold \
	  && skjold audit
# NB: For portability, we use '.' (sh etc.) instead of 'source' (bash).

# Debug print environment variables
debug:
	@echo "GITHUB_TOKEN = ${GITHUB_TOKEN}"
	@echo "SKJOLD_GITHUB_API_TOKEN = $${SKJOLD_GITHUB_API_TOKEN}"
	@echo "Is SKJOLD_GITHUB_API_TOKEN set? $${SKJOLD_GITHUB_API_TOKEN:+yes}"

# EOF

=== libraries/Cabal/doc/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.10
# by the following command:
#
#    pip-compile requirements.in
#
alabaster==0.7.12
    # via sphinx
babel==2.9.1
    # via sphinx
certifi==2022.12.7
    # via
    #   -r requirements.in
    #   requests
charset-normalizer==2.0.7
    # via requests
docutils==0.18.1
    # via
    #   sphinx
    #   sphinx-jsonschema
    #   sphinx-rtd-theme
idna==2.10
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.3
    # via
    #   -r requirements.in
    #   sphinx
jsonpointer==2.3
    # via sphinx-jsonschema
markupsafe==2.1.2
    # via jinja2
packaging==23.0
    # via sphinx
pygments==2.14.0
    # via
    #   -r requirements.in
    #   sphinx
pytz==2021.3
    # via babel
pyyaml==6.0.1
    # via sphinx-jsonschema
requests==2.26.0
    # via
    #   sphinx
    #   sphinx-jsonschema
snowballstemmer==2.1.0
    # via sphinx
sphinx==5.3.0
    # via
    #   -r requirements.in
    #   sphinx-rtd-theme
    #   sphinxnotes-strike
sphinx-jsonschema==1.16.11
    # via -r requirements.in
sphinx-rtd-theme==1.2.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.2
    # via sphinx
sphinxcontrib-devhelp==1.0.2
    # via sphinx
sphinxcontrib-htmlhelp==2.0.0
    # via sphinx
sphinxcontrib-jquery==2.0.0
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.3
    # via sphinx
sphinxcontrib-serializinghtml==1.1.5
    # via sphinx
sphinxnotes-strike==1.1
    # via -r requirements.in
urllib3==1.26.7
    # via requests

# The following packages are considered to be unsafe in a requirements file:
# setuptools

=== libraries/stm/bench/Makefile ===
GHC=ghc

# Run chanbench for 4 different channel types, 3 different benchmarks
all:
	for i in CHAN TCHAN TQUEUE TBQUEUE; do $(GHC) -D$$i -O2 -fforce-recomp chanbench.hs -o chanbench-$$i; done
	for i in 0 1 2; do echo; echo === test $$i ===; for j in CHAN TCHAN TQUEUE TBQUEUE; do printf "%-10s" $$j; time ./chanbench-$$j $$i 2000000; done; done

=== nofib/gc/constraints/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

FAST_OPTS = 6
NORM_OPTS = 7
SLOW_OPTS = 8

ifeq "$(HEAP)" "LARGE"
PROG_ARGS += +RTS -H330m -RTS
endif
ifeq "$(HEAP)" "OLD"
PROG_ARGS += +RTS -H10m -RTS
endif

include $(TOP)/mk/target.mk

=== nofib/gc/hash/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

FAST_OPTS = 1000000
NORM_OPTS = 5000000
SLOW_OPTS = 100000000

ifeq "$(HEAP)" "LARGE"
PROG_ARGS += +RTS -H430m -RTS
endif

include $(TOP)/mk/target.mk

=== nofib/gc/lcss/Makefile ===
TOP=../..
include $(TOP)/mk/boilerplate.mk

FAST_OPTS = 1 2 2000 1000 1001 2000
NORM_OPTS = 1 2 2000 1000 1001 4000
SLOW_OPTS = 1 2 4000 1000 1001 4000

ifeq "$(HEAP)" "LARGE"
PROG_ARGS += +RTS -H256m -RTS
endif

include $(TOP)/mk/target.mk

=== nofib/imaginary/bernouilli/Makefile ===
TOP = ../..
include $(TOP)/mk/boilerplate.mk

# Override default SRCS; the default is all source files, but
# we don't want to include paraffins.c
SRCS=Main.hs NofibUtils.hs

FAST_OPTS =  60
NORM_OPTS = 180
SLOW_OPTS = 320

include $(TOP)/mk/target.mk

=== debian/changelog ===
ghc (9.6.6-4) unstable; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Add patch to fix FTBFS on alpha (Closes#: 1086830)

  [ Gianfranco Costamagna ]
  * Add binutils-gold to armel and armhf, according to rules file
    (Closes: #1094995)

  [ 王鑫 <wangxin03@loongson.cn> ]
  * Update loongarch64 patch with new upstream backported commits
   (Closes: #1089921)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 17 Feb 2025 09:44:23 +0100

ghc (9.6.6-3) unstable; urgency=medium

  [ fanpeng <fanpeng@loongson.cn> ]
  * debian/patches/7e2d3eb507da184cf3337d36715fd82a81643d91.patch:
    - upstream fix for loong64 build failures (Closes: #1085966)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 06 Nov 2024 00:21:23 +0100

ghc (9.6.6-2) unstable; urgency=medium

  * Update 'hadrian-enable-interpreter' patch to re-enable GHCi
    on all architectures (Closes: #1081883)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 16 Sep 2024 00:17:25 +0300

ghc (9.6.6-1) unstable; urgency=medium

  * Upload to unstable
  * Declare compliance with Debian policy 4.7.0
  * Use libnuma-dev only on architectures where it's available
  * Don't run tests on crossbuild (Closes: #1081069)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 11 Sep 2024 15:16:54 +0300

ghc (9.6.6-1~exp5) experimental; urgency=medium

  * Use gold on arm{el,hf}
  * Drop redundant build-dep on devscripts
  * Add missing build-dep on libnuma-dev
  * Add missing dependency on libstdc++-X-dev library

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 26 Aug 2024 17:37:05 +0300

ghc (9.6.6-1~exp4) experimental; urgency=medium

  * Bump hadrian dependency
  * Bump required LLVM version to 18
  * Backport upstream patch to fix incorrect use of word-sized types on
    32-bit systems
  * Use system's default linker (bfd) instead of gold (Closes: #1079099)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Mon, 26 Aug 2024 11:31:53 +0300

ghc (9.6.6-1~exp3) experimental; urgency=medium

  [ Peng Fan <fanpeng@loongson.cn> ]
  * Add loong64 support (Closes: #1071151)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 13 Aug 2024 14:17:49 +0200

ghc (9.6.6-1~exp2) experimental; urgency=medium

  * Set llvm-version back to 17, FBTFS

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 17 Jul 2024 08:51:18 +0200

ghc (9.6.6-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Jul 2024 14:17:29 +0200

ghc (9.6.5-1~exp2) experimental; urgency=medium

  [ John Paul Adrian Glaubitz ]
  * Pass --disable-ld-override in EXTRA_INSTALL_CONFIGURE_FLAGS
    (Closes: #1073159)

  [ Gianfranco Costamagna ]
  * Bump required llvm-version to 18

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Jul 2024 13:58:17 +0200

ghc (9.6.5-1~exp1) experimental; urgency=medium

  * New upstream release
  * Backport patch to use newer LLVM versions
  * Use LLVM 17
  * Build registerised on loong64
  * Add hadrian bootstrap plan for GHC v9.6.5

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Fri, 03 May 2024 10:15:54 +0300

ghc (9.6.4-1~exp1) experimental; urgency=medium

  * New upstream release
  * Build unregisterised on loong64 since llvm-15 is not available
  * Build unregisterised on powerpc (Closes: #1060196)
  * Do not error out when cross building, let it fail instead

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 13 Jan 2024 16:22:36 +0200

ghc (9.6.3-1~exp2) experimental; urgency=medium

  * Backport upstream patch to fix build on armel/armhf
  * Depend on LLVM for loong64

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Tue, 26 Dec 2023 10:08:47 +0200

ghc (9.6.3-1~exp1) experimental; urgency=medium

  [ Gianfranco Costamagna ]
  * New upstream release (Closes: #1053588)
  * drop patches now upstream
    - newer-llvm
    - fix-cross-compilation
    - fix-hs_cmpxchg64
    - fix-32-bit-unreg

  [ Ilias Tsitsimpis ]
  * Backport upstream fixes
  * Bump hadrian dependency
  * Patch Cabal and add support for sparc64.
    Thanks to John Paul Adrian Glaubitz for the fix (Closes: #1056033).
  * Add support for hurd-i386.
    Thanks to Samuel Thibault for the fix (Closes: #1056305).
  * Update d/rules to work with newer version

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Thu, 21 Dec 2023 09:21:59 +0200

ghc (9.4.7-5) unstable; urgency=medium

  * Backport upstream patches to fix issues with 64-bit time_t (Closes:
    #1068586)
  * Build unregisterised on powerpc (Closes: #1060196)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Wed, 10 Apr 2024 14:24:01 +0300

ghc (9.4.7-4) unstable; urgency=medium

  * Backport upstream patch to fix compilation with GCC 14 (Closes: #1068179)

 -- Ilias Tsitsimpis <iliastsi@debian.org>  Sat, 06 Apr 2024 10:34:53 +0300

=== debian/control ===
Source: ghc
Section: haskell
Priority: optional
Maintainer: Debian Haskell Group <pkg-haskell-maintainers@lists.alioth.debian.org>
Uploaders:
 Clint Adams <clint@debian.org>,
 Ilias Tsitsimpis <iliastsi@debian.org>
Standards-Version: 4.7.0
Rules-Requires-Root: no
Build-Depends:
  debhelper-compat (= 12),
  haskell-devscripts-minimal (>= 0.16.31) <!cross>,
  binutils-gold [armel armhf],
  gcc,
  g++,
  pkg-config,
  ghc:native (>= 9.2),
  hadrian:native (>= 9.6.6) <!pkg.ghc.nohadrian>,
  hadrian:native (<< 9.6.7~) <!pkg.ghc.nohadrian>,
  llvm-18 [armel armhf s390x riscv64 loong64],
  libgmp-dev,
  libffi-dev,
  libncurses-dev,
  libnuma-dev [linux-any],
  python3:native,
  python3-sphinx <!cross>,
Build-Depends-Indep:
  hscolour,
  python3-sphinx-rtd-theme,
Build-Conflicts: ccache
Homepage: https://haskell.org/ghc/
Vcs-Git: https://salsa.debian.org/haskell-team/DHG_packages.git [p/ghc]
Vcs-Browser: https://salsa.debian.org/haskell-team/DHG_packages/tree/master/p/ghc

Package: ghc
Architecture: any
Depends:
  llvm-18 [armel armhf s390x riscv64 loong64],
  binutils-gold [armel armhf],
  gcc,
  libgmp-dev,
  libffi-dev,
  libbsd-dev,
  libc6-dev,
  libncurses-dev,
  libnuma-dev [linux-any],
  ${shlibs:Depends},
  ${misc:Depends}
Recommends:
  ${shlibs:Recommends},
Pre-Depends: dpkg (>= 1.16.1)
Provides:
  haskell-compiler,
  ghc-dynamic,
  ${ghci},
  ${provided-devs},
  ${haskell:Provides},
  haddock,
  ghc-haddock,
  ${haddock:Provides}
Replaces: ${conflicting-devs}
Breaks: ${conflicting-devs}
Suggests: perl, ghc-prof, ghc-doc, llvm-18
Description: The Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found at
 https://www.haskell.org/documentation/.

Package: ghc-prof
Architecture: any
Provides: ${provided-profs}, ${haskell:Provides}
Depends: ghc (= ${binary:Version}), ${misc:Depends}
Description: Profiling libraries for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found at
 https://www.haskell.org/documentation/.
 .
 This package contains additional profiling libraries. They are only needed,
 if you want to take a closer look on where exactly your program burns CPU
 cycles.

Package: ghc-doc
Section: doc
Architecture: all
Provides: ${provided-docs}
Depends: ${haddock:Depends}, ${misc:Depends}, perl, libjs-mathjax
Pre-Depends: dpkg (>= 1.16.1)
Description: Documentation for the Glasgow Haskell Compilation system
 The Glorious Glasgow Haskell Compilation system (GHC) is a compiler for
 Haskell.
 .
 Haskell is "the" standard lazy functional programming language.  The language
 definition and additional documentation can be found at
 https://www.haskell.org/documentation/.
 .
 This package includes HTML, DVI and PS versions of the SGML-based
 documentation around GHC.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# This file is public domain software, originally written by Joey Hess.
#
# This version is for a multibinary package. It also allows you to build any
# of the binary packages independantly, via binary-<package> targets.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# Set a dummy HOME variable upon build. Some build daemons do not set HOME, but
# ghc-cabal expects it to be available.
export HOME = /homedoesnotexistatbuildtime

# From /usr/share/doc/autotools-dev/examples/rules.gz:
export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_ARCH      ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
export DEB_TARGET_ARCH_ENDIAN  ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_ENDIAN)

# Bootstrap GHC
export GHC := $(firstword $(shell bash -c "type -p ghc"))

# The version of the GHC we are building
ProjectVersion := $(shell cat VERSION)

# Move this somewhere else?
DEB_HOOGLE_TXT_DIR := /usr/lib/ghc-doc/hoogle/


# --------------------------------------------------------------------
# Build configuration
# For configuration options, see
# https://www.haskell.org/ghc/blog/20220805-make-to-hadrian.html
# https://gitlab.haskell.org/ghc/ghc/-/blob/master/hadrian/doc/user-settings.md

# Explicitly pass 'host', 'build' and 'target', because the configuration
# script fails to properly detect them (e.g., it detects 'x86_64-unknown-linux'
# instead of 'x86_64-linux-gnu'.
EXTRA_CONFIGURE_FLAGS += --host $(DEB_BUILD_GNU_TYPE) --build $(DEB_BUILD_GNU_TYPE) --target $(DEB_HOST_GNU_TYPE)
EXTRA_INSTALL_CONFIGURE_FLAGS += --host $(DEB_BUILD_GNU_TYPE) --build $(DEB_BUILD_GNU_TYPE) --target $(DEB_HOST_GNU_TYPE)

# We're cross-building if DEB_BUILD_GNU_TYPE != DEB_HOST_GNU_TYPE
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
  # EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
  # EXTRA_HADRIAN_FLAGS += --integer-simple
  EXTRA_HADRIAN_FLAGS += --flavour=quickest
  # Do not build docs *at all* (avoid dependency on Sphinx)
  EXTRA_HADRIAN_FLAGS += --docs=none
  BUILD_CROSS = YES
else
  BUILD_CROSS = NO
endif

# Use system's default ld (ld.bfd) rather than ld.gold.
# gold is abandoned and broken on many Debian platforms.
# See also:
#  https://bugs.debian.org/1079099
#  https://gitlab.haskell.org/ghc/ghc/-/issues/22215
#  https://gitlab.haskell.org/ghc/ghc/-/commit/c702696258f
#  https://gitlab.haskell.org/ghc/ghc/-/issues/25093
EXTRA_CONFIGURE_FLAGS += --disable-ld-override
EXTRA_INSTALL_CONFIGURE_FLAGS += --disable-ld-override

# BFD doesn't work on arm{el,hf}
# See https://gitlab.haskell.org/ghc/ghc/-/blob/3a18c0fa2edcd61b0c3b470661791b09501c4c2b/m4/check_ld_copy_bug.m4
# and https://sourceware.org/bugzilla/show_bug.cgi?id=16177
ifneq (,$(filter armel armhf, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-ld-override
  EXTRA_INSTALL_CONFIGURE_FLAGS += --enable-ld-override
endif

# From GHC 8.10 and later, native code generator support for legacy x87
# floating point coprocessor has been removed. GHC now only support floating
# point via SSE2. This causes a baseline violation on Debian for i386 where
# there is no SSE support. Fallback to unregisterised builds on i386.
ifneq (,$(filter i386 powerpcspe x32, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
endif

# See https://bugs.debian.org/1060196
ifneq (,$(filter powerpc, $(DEB_HOST_ARCH)))
  EXTRA_CONFIGURE_FLAGS += --enable-unregisterised
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.hs.opts += -optc--param -optcggc-min-expand=10 -optc-O3"
endif


ifneq (,$(filter armhf, $(DEB_HOST_ARCH)))
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.hs.opts += -D__ARM_PCS_VFP"
endif

ifneq (,$(filter i386 mips mipsel hppa, $(DEB_HOST_ARCH)))
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.hs.opts += -optc--param -optcggc-min-expand=10"
endif

# mips64el compiles fine without it. Keep this commented out in
# case we need it in the future.
# ifneq (,$(filter mips64el, $(DEB_HOST_ARCH)))
# 	# Pass -mxgot to fix relocation linker errors
# 	EXTRA_HADRIAN_FLAGS += "*.*.ghc.hs.opts += -optc-mxgot"
# endif

ifneq (,$(filter x32, $(DEB_HOST_ARCH)))
  EXTRA_HADRIAN_FLAGS += --integer-simple
endif

ifneq (,$(filter noopt, $(DEB_BUILD_OPTIONS)))
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.*.opts += -H64m -O0"
  EXTRA_HADRIAN_FLAGS += "*.*.rts.*.opts += -O0"
endif

ifneq (,$(filter loong64, $(DEB_HOST_ARCH)))
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.c.opts += -optc-mcmodel=medium"
  EXTRA_HADRIAN_FLAGS += "*.*.ghc.hs.opts += -optc-mcmodel=medium"
  EXTRA_HADRIAN_FLAGS += "*.*.cc.c.opts += -optc-mcmodel=medium"
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# Use system libffi
EXTRA_CONFIGURE_FLAGS += --with-system-libffi

# Set LLVM version
# If we don't set these, then the default value (llc / opt) will not work
# on architectures where the default llc/opt version is different than
# one of the supported versions.
EXTRA_CONFIGURE_FLAGS += LLC=llc-18 OPT=opt-18
EXTRA_INSTALL_CONFIGURE_FLAGS += LLC=llc-18 OPT=opt-18


%:
	dh $@

# --------------------------------------------------------------------
# Configure hadrian

hadrian/hadrian:
# Case A (default, with hadrian package available): the builder did not select
# the "pkg.ghc.nohadrian" build profile. In this case, we use the distro's
# hadrian.
ifeq (,$(findstring pkg.ghc.nohadrian,$(DEB_BUILD_PROFILES)))
	test -f "$$(which hadrian)"
	ln -s "$$(which hadrian)" hadrian/hadrian
# Case B (without hadrian): the builder selected the "pkg.ghc.nohadrian" build
# profile. In this case, we use the ./hadrian/bootstrap/bootstrap.py script in
# order to download the build-dependencies for hadrian, and build it ourselves
# with our bootstrap ghc.
else
	cd hadrian && \
		./bootstrap/bootstrap.py && \
		test -f _build/bin/hadrian && \
		ln -s _build/bin/hadrian hadrian
endif

.PHONY: clean-hadrian
clean-hadrian:
	rm -f hadrian/hadrian
	rm -rf hadrian/_build

# --------------------------------------------------------------------
# Configure/Build rules

override_dh_autoreconf:
	dh_autoreconf ./boot.source

override_dh_auto_configure:
	dh_auto_configure -- $(EXTRA_CONFIGURE_FLAGS)

override_dh_auto_build-arch: export LC_ALL=C.UTF-8
override_dh_auto_build-arch: hadrian/hadrian
ifeq (YES,$(BUILD_CROSS))
	# See https://gitlab.haskell.org/ghc/ghc/-/issues/23975
	# and https://gitlab.haskell.org/ghc/ghc/-/issues/22006
	$(warning cross-compilation is not supported)
endif
	hadrian/hadrian \
		-V -j$(NUMJOBS) \
		--docs=no-haddocks --docs=no-sphinx-html --docs=no-sphinx-pdfs \
		binary-dist-dir \
		$(EXTRA_HADRIAN_FLAGS)
ifeq (NO,$(BUILD_CROSS))
	# I have noticed that on some rare cases the package cache
	# generated for stage2 is stale. This is probably an upstream bug,
	# and it wouldn't affect us (the package cache for binary-dist-dir is
	# correct), but we use ghc-pkg from stage2 when we generate our control file.
	# Maybe we should consider using ghc-pkg from binary-dist-dir instead.
	# As a work-around for now, regenerate the stage2 package cache.
	_build/stage1/bin/ghc-pkg recache
endif

# This rule is a superset of 'override_dh_auto_build-arch'. It builds everything
# that the '-arch' rule builds, and then docs on top.
# The reason we split those two rules, is to avoid building docs on arch
# builders, because building docs requires running Haddock, which fails with
# OOM errors on some weak builders.
override_dh_auto_build-indep: export LC_ALL=C.UTF-8
override_dh_auto_build-indep: hadrian/hadrian
ifeq (YES,$(BUILD_CROSS))
	$(error override_dh_auto_build-indep is not supported when cross compiling)
endif
	hadrian/hadrian \
		-V -j$(NUMJOBS) \
		--docs=no-sphinx-pdfs \
		binary-dist-dir \
		$(EXTRA_HADRIAN_FLAGS)
	# I have noticed that on some rare cases the package cache
	# generated for stage2 is stale. This is probably an upstream bug,
